diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 638f06345..de82047a8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -176,7 +176,8 @@ public abstract class OptionsPages {
                     .withComponent(new FloatOptionComponent(GameSettings.BLOCK_OUTLINE_WIDTH))
                 )
                 .withComponent(new OptionsCategory("gui.options.page.video.category.post_processing")
-                    .withComponent(new FloatOptionComponent(GameSettings.COLOR_CORRECTION))
+                    .withComponent(new FloatOptionComponent(GameSettings.COLOR_CORRECTION_OVERWORLD))
+                    .withComponent(new FloatOptionComponent(GameSettings.COLOR_CORRECTION_NETHER))
                     .withComponent(new BooleanOptionComponent(GameSettings.FXAA))
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.BLOOM))
                     .withComponent(new FloatOptionComponent(GameSettings.HEAT_HAZE))
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index b21898223..9f8e0ff4f 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -298,7 +298,8 @@ public final class GameSettings {
         }));
     public static final @NotNull OptionInteger PLAYER_LIST_POSITION = register(new OptionInteger("playerListPosition", 2));
     public static final @NotNull OptionInteger LAST_CREATIVE_INVENTORY_PAGE = register(new OptionInteger("lastCreativeInventoryPage", 0));
-    public static final @NotNull OptionFloat COLOR_CORRECTION = register(new OptionFloat("colorCorrection", 0.5f));
+    public static final @NotNull OptionFloat COLOR_CORRECTION_OVERWORLD = register(new OptionFloat("colorCorrectionOverworld", 0.5f));
+    public static final @NotNull OptionFloat COLOR_CORRECTION_NETHER = register(new OptionFloat("colorCorrectionNether", 0.5f));
     public static final @NotNull OptionBoolean SNEAK_TOGGLE = register(new OptionBoolean("sneakToggle", false));
     public static final @NotNull OptionFloat AUTOSAVE_TIMER = register(new OptionFloat("autosaveTimer", 0.04166666666F)
         .addOnChangeCallback((mc, option) -> {
diff --git a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index 125e5a0ff..9e56daab6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -68,7 +68,9 @@ public class PostProcessingManager {
         if (this.mc.currentWorld == null || this.mc.thePlayer == null) return;
 
         this.reset();
-        float ccValue = GameSettings.COLOR_CORRECTION.value;
+        float ccValue = this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.NETHER)
+            ? GameSettings.COLOR_CORRECTION_NETHER.value
+            : GameSettings.COLOR_CORRECTION_OVERWORLD.value;
         boolean haze = GameSettings.HEAT_HAZE.value != 0;
 
         final float y = (float) this.mc.thePlayer.y;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 0a10aed30..3bb84b6bb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -483,7 +483,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.MOBSPAWNER, loadDataModel("minecraft:block/mobspawner")));
         addDispatch(new BlockModelGeneric<>(Blocks.MOBSPAWNER_DEACTIVATED, loadDataModel("minecraft:block/mobspawner_deactivated")));
 
-        addDispatch(new BlockModelGeneric<>(Blocks.WORKBENCH, loadDataModel("minecraft:block/workbench")));
+        addDispatch(new BlockModelGenericWorkbench<>(Blocks.WORKBENCH, loadDataModel("minecraft:block/workbench")));
 
         addDispatch(new BlockModelGenericFurnace<>(Blocks.FURNACE_STONE_IDLE, "minecraft:block/furnace_stone/idle"));
         addDispatch(new BlockModelGenericFurnace<>(Blocks.FURNACE_STONE_ACTIVE, "minecraft:block/furnace_stone/active"));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 1dba8e7f7..b6dfdbfe1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -128,13 +128,13 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 );
 
                 tessellator.setLightmapCoord1i(lightSE);
-                tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1,
+                tessellator.addVertexWithUV(x + 1, y + hes, z + 1,
                     tex.getSubIconU(((0.25) * cos - (0.25) * sin) + 0.5),
                     tex.getSubIconV(((0.25) * sin + (0.25) * cos) + 0.5)
                 );
 
                 tessellator.setLightmapCoord1i(lightNE);
-                tessellator.addVertexWithUV(x + 1, (float) y + he, z,
+                tessellator.addVertexWithUV(x + 1, y + he, z,
                     tex.getSubIconU(((0.25) * cos - (-0.25) * sin) + 0.5),
                     tex.getSubIconV(((0.25) * sin + (-0.25) * cos) + 0.5)
                 );
@@ -142,16 +142,16 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 tessellator.setNormal(0, 1, 0);
 
                 tessellator.setLightmapCoord1i(lightNW);
-                tessellator.addVertexWithUV(x, (float) y + h, z, tex.getIconUMin(), tex.getIconVMax());
+                tessellator.addVertexWithUV(x, y + h, z, tex.getIconUMin(), tex.getIconVMax());
 
                 tessellator.setLightmapCoord1i(lightSW);
-                tessellator.addVertexWithUV(x, (float) y + hs, z + 1, tex.getIconUMax(), tex.getIconVMax());
+                tessellator.addVertexWithUV(x, y + hs, z + 1, tex.getIconUMax(), tex.getIconVMax());
 
                 tessellator.setLightmapCoord1i(lightSE);
-                tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, tex.getIconUMax(), tex.getIconVMin());
+                tessellator.addVertexWithUV(x + 1, y + hes, z + 1, tex.getIconUMax(), tex.getIconVMin());
 
                 tessellator.setLightmapCoord1i(lightNE);
-                tessellator.addVertexWithUV(x + 1, (float) y + he, z, tex.getIconUMin(), tex.getIconVMin());
+                tessellator.addVertexWithUV(x + 1, y + he, z, tex.getIconUMin(), tex.getIconVMin());
 
                 if (worldSource.getWorldType().hasTag(WorldTypeTags.NETHER) && this.block.getLogic().fluid instanceof FluidWater) {
                     if (GameSettings.BIOME_WATER.value) {
@@ -170,31 +170,31 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
 
                     switch (random.nextInt(4)) {
                         case 0: {
-                            tessellator.addVertexWithUV(x, (float) y + h, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
-                            tessellator.addVertexWithUV(x, (float) y + hs, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
-                            tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
-                            tessellator.addVertexWithUV(x + 1, (float) y + he, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x, y + h, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x, y + hs, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x + 1, y + hes, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x + 1, y + he, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
                             break;
                         }
                         case 1: {
-                            tessellator.addVertexWithUV(x, (float) y + h, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
-                            tessellator.addVertexWithUV(x, (float) y + hs, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
-                            tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
-                            tessellator.addVertexWithUV(x + 1, (float) y + he, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x, y + h, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x, y + hs, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x + 1, y + hes, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x + 1, y + he, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
                             break;
                         }
                         case 2: {
-                            tessellator.addVertexWithUV(x, (float) y + h, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
-                            tessellator.addVertexWithUV(x, (float) y + hs, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
-                            tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
-                            tessellator.addVertexWithUV(x + 1, (float) y + he, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x, y + h, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x, y + hs, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x + 1, y + hes, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x + 1, y + he, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
                             break;
                         }
                         case 3: {
-                            tessellator.addVertexWithUV(x, (float) y + h, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
-                            tessellator.addVertexWithUV(x, (float) y + hs, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
-                            tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
-                            tessellator.addVertexWithUV(x + 1, (float) y + he, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x, y + h, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x, y + hs, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x + 1, y + hes, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x + 1, y + he, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
                             break;
                         }
                     }
@@ -224,44 +224,45 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             if (!renderBlocks.renderAllFaces && !sideRenderFlags[side]) {
                 continue;
             }
-            float f13;
-            float f15;
-            float x1;
-            float z1;
-            float x2;
-            float z2;
+            double f13;
+            double f15;
+            double x1;
+            double z1;
+            double x2;
+            double z2;
+            final double ep = 0.0001;
             switch (side) {
                 case 0 -> { // North
                     f13 = h;
                     f15 = he;
-                    x1 = x + 0.0001f;
-                    x2 = x + 1 - 0.0001f;
-                    z1 = z + 0.0001f;
-                    z2 = z + 0.0001f;
+                    x1 = x - ep;
+                    x2 = x + 1 + ep;
+                    z1 = z + ep;
+                    z2 = z + ep;
                 }
                 case 1 -> { // South
                     f13 = hes;
                     f15 = hs;
-                    x1 = x + 1 - 0.0001f;
-                    x2 = x + 0.0001f;
-                    z1 = z + 1 - 0.0001f;
-                    z2 = z + 1 - 0.001f;
+                    x1 = x + 1 + ep;
+                    x2 = x - ep;
+                    z1 = z + 1 - ep;
+                    z2 = z + 1 - ep;
                 }
                 case 2 -> { // West
                     f13 = hs;
                     f15 = h;
-                    x1 = x + 0.0001f;
-                    x2 = x + 0.0001f;
-                    z1 = z + 1 - 0.0001f;
-                    z2 = z + 0.0001f;
+                    x1 = x + ep;
+                    x2 = x + ep;
+                    z1 = z + 1 + ep;
+                    z2 = z - ep;
                 }
                 default -> { // East
                     f13 = he;
                     f15 = hes;
-                    x1 = x + 1 - 0.0001f;
-                    x2 = x + 1 - 0.0001f;
-                    z1 = z + 0.0001f;
-                    z2 = z + 1 - 0.0001f;
+                    x1 = x + 1 - ep;
+                    x2 = x + 1 - ep;
+                    z1 = z - ep;
+                    z2 = z + 1 + ep;
                 }
             }
             didRender = true;
@@ -277,8 +278,8 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 case 2 -> tessellator.setNormal(-1, 0, 0);
                 case 3 -> tessellator.setNormal(1, 0, 0);
             }
-            tessellator.addVertexWithUV(x1, (float) y + f13, z1, u1, v1);
-            tessellator.addVertexWithUV(x2, (float) y + f15, z2, u2, v2);
+            tessellator.addVertexWithUV(x1, y + f13, z1, u1, v1);
+            tessellator.addVertexWithUV(x2, y + f15, z2, u2, v2);
             tessellator.addVertexWithUV(x2, y, z2, u2, v3);
             tessellator.addVertexWithUV(x1, y, z1, u1, v3);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericGrass.java
index 2426570f9..cb7ec4cfb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericGrass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericGrass.java
@@ -12,16 +12,23 @@ import org.useless.dragonfly.models.block.StaticBlockModel;
 
 public class BlockModelGenericGrass<T extends BlockLogic> extends BlockModelGeneric<T> {
     public final @NotNull StaticBlockModel snowy;
+    public final @NotNull StaticBlockModel ashy;
     public BlockModelGenericGrass(@NotNull Block<T> block) {
         super(block, BlockModelDispatcher.loadDataModel("minecraft:block/grass"));
         this.snowy = BlockModelDispatcher.loadDataModel("minecraft:block/grass_snowy").asModel();
+        this.ashy = BlockModelDispatcher.loadDataModel("minecraft:block/grass_ashy").asModel();
+
     }
 
     @Override
     public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
-        if (source.getBlockType(tilePosc.up(new TilePos())) == Blocks.LAYER_SNOW) {
+        TilePos up = tilePosc.up(new TilePos());
+        if (source.getBlockType(up) == Blocks.LAYER_SNOW) {
             return this.snowy;
         }
+        if (source.getBlockType(up) == Blocks.LAYER_ASH) {
+            return this.ashy;
+        }
         return super.getModel(source, tilePosc);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java
index ad9efb476..081b83515 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java
@@ -24,7 +24,7 @@ public class BlockModelGenericLayer<T extends BlockLogic> extends BlockModelGene
 
     @Override
     public @NotNull StaticBlockModel getModelFromData(int data) {
-        return this.models[(data & BlockLogicLayerBase.MASK_HEIGHT) % this.models.length];
+        return this.models[Math.min(data & BlockLogicLayerBase.MASK_HEIGHT, this.models.length - 1)];
     }
 
     private final @NotNull TilePos queryPos = new TilePos();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericWorkbench.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericWorkbench.java
new file mode 100644
index 000000000..a771072af
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericWorkbench.java
@@ -0,0 +1,34 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicRotatable;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericWorkbench<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public BlockModelGenericWorkbench(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelGenericWorkbench(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        Direction direction = BlockLogicRotatable.getDirectionFromMeta(worldSource.getBlockData(tilePos));
+        int rotY = switch (direction) {
+            case EAST, WEST -> 1;
+            default -> 0;
+        };
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, rotY, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
index 8118f9267..dc5515286 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
@@ -12,6 +12,8 @@ public class DynamicTextureLavaFlowing extends DynamicTexture {
 	private float[] arr2;
 	private float[] arr3;
 	private float[] arr4;
+	private int width;
+	private int height;
 	private int ticks = 0;
 
 	public DynamicTextureLavaFlowing(@NotNull IconCoordinate targetTexture) {
@@ -22,56 +24,50 @@ public class DynamicTextureLavaFlowing extends DynamicTexture {
 	public void postInit() {
 		initTexture();
 
-        this.arr1 = new float[this.targetTexture.getArea()];
-        this.arr2 = new float[this.targetTexture.getArea()];
-        this.arr3 = new float[this.targetTexture.getArea()];
-        this.arr4 = new float[this.targetTexture.getArea()];
+		this.width = this.targetTexture.width/2;
+		this.height = this.targetTexture.height/2;
+        this.arr1 = new float[this.width * this.height];
+        this.arr2 = new float[this.width * this.height];
+        this.arr3 = new float[this.width * this.height];
+        this.arr4 = new float[this.width * this.height];
 	}
 
 	@Override
 	public void update() {
 		++this.ticks;
 
-		int y;
-		float var3;
-		int var5;
-		int _x;
-		int _y;
-		int var8;
-		int var9;
-
         byte[] imageData = getImageData(this.layerColor);
-		for (int x = 0; x < this.targetTexture.width; ++x) {
-			for (y = 0; y < this.targetTexture.height; ++y) {
-				var3 = 0.0F;
-				int var4 = (int) (MathHelper.sin((float) y * MathHelper.PI * 2.0F / this.targetTexture.height) * 1.2F);
-				var5 = (int) (MathHelper.sin((float) x * MathHelper.PI * 2.0F / this.targetTexture.width) * 1.2F);
-
-				for (_x = x - 1; _x <= x + 1; ++_x) {
-					for (_y = y - 1; _y <= y + 1; ++_y) {
-						var8 = floorMod(_x + var4, this.targetTexture.width);
-						var9 = floorMod(_y + var5, this.targetTexture.height);
-						var3 += this.arr1[var8 + var9 * this.targetTexture.width];
+        for (int x = 0; x < this.width; ++x) {
+			for (int y = 0; y < this.height; ++y) {
+				float var3 = 0.0F;
+				int var4 = (int) (MathHelper.sin((float) y * MathHelper.PI * 2.0F / this.height) * 1.2F);
+				int var5 = (int) (MathHelper.sin((float) x * MathHelper.PI * 2.0F / this.width) * 1.2F);
+
+				for (int _x = x - 1; _x <= x + 1; ++_x) {
+					for (int _y = y - 1; _y <= y + 1; ++_y) {
+                        int var8 = Math.floorMod(_x + var4, this.width);
+                        int var9 = Math.floorMod(_y + var5, this.height);
+                        var3 += this.arr1[var8 + var9 * this.width];
 					}
 				}
 
-				this.arr2[x + y * this.targetTexture.width] = var3 / 10.0F
-						+ (this.arr3[(floorMod(x, this.targetTexture.width))
-						+ (floorMod(y, this.targetTexture.height)) * this.targetTexture.width]
-						+ this.arr3[(floorMod(x + 1, this.targetTexture.width))
-						+ (floorMod(y, this.targetTexture.height)) * this.targetTexture.width]
-						+ this.arr3[(floorMod(x + 1, this.targetTexture.width))
-						+ (floorMod(y + 1, this.targetTexture.height)) * this.targetTexture.width]
-						+ this.arr3[(floorMod(x, this.targetTexture.width))
-						+ (floorMod(y + 1, this.targetTexture.height)) * this.targetTexture.width]) / 4.0F * 0.8F;
-				this.arr3[x + y * this.targetTexture.width] += this.arr4[x + y * this.targetTexture.width] * 0.01F;
-				if (this.arr3[x + y * this.targetTexture.width] < 0.0F) {
-					this.arr3[x + y * this.targetTexture.width] = 0.0F;
+				this.arr2[x + y * this.width] = var3 / 10.0F
+						+ (this.arr3[(floorMod(x, this.width))
+						+ (floorMod(y, this.height)) * this.width]
+						+ this.arr3[(floorMod(x + 1, this.width))
+						+ (floorMod(y, this.height)) * this.width]
+						+ this.arr3[(floorMod(x + 1, this.width))
+						+ (floorMod(y + 1, this.height)) * this.width]
+						+ this.arr3[(floorMod(x, this.width))
+						+ (floorMod(y + 1, this.height)) * this.width]) / 4.0F * 0.8F;
+				this.arr3[x + y * this.width] += this.arr4[x + y * this.width] * 0.01F;
+				if (this.arr3[x + y * this.width] < 0.0F) {
+					this.arr3[x + y * this.width] = 0.0F;
 				}
 
-				this.arr4[x + y * this.targetTexture.width] -= 0.06F;
+				this.arr4[x + y * this.width] -= 0.06F;
 				if (java.lang.Math.random() < 0.005D) {
-					this.arr4[x + y * this.targetTexture.width] = 1.5F;
+					this.arr4[x + y * this.width] = 1.5F;
 				}
 			}
 		}
@@ -80,24 +76,28 @@ public class DynamicTextureLavaFlowing extends DynamicTexture {
 		this.arr2 = this.arr1;
 		this.arr1 = var11;
 
-		for (int i = 0; i < this.targetTexture.getArea(); ++i) {
-			var3 = this.arr1[floorMod(i - this.ticks / 3 * this.targetTexture.width, this.targetTexture.getArea())] * 2.0F;
-			if (var3 > 1.0F) {
-				var3 = 1.0F;
-			}
+		for (int x = 0; x < this.targetTexture.width; x++) {
+			for (int y = 0; y < this.targetTexture.height; y++) {
+				int i = y * this.targetTexture.width + x;
+				int i2 = (y % this.height) * this.width + (x % this.width);
+				float var3 = this.arr1[floorMod(i2 - this.ticks / 3 * this.width, this.arr1.length)] * 2.0F;
+				if (var3 > 1.0F) {
+					var3 = 1.0F;
+				}
 
-			if (var3 < 0.0F) {
-				var3 = 0.0F;
-			}
+				if (var3 < 0.0F) {
+					var3 = 0.0F;
+				}
 
-			var5 = (int) (var3 * 100.0F + 155.0F);
-			_x = (int) (var3 * var3 * 255.0F);
-			_y = (int) (var3 * var3 * var3 * var3 * 128.0F);
+				int var5 = (int) (var3 * 100.0F + 155.0F);
+				int _x = (int) (var3 * var3 * 255.0F);
+				int _y = (int) (var3 * var3 * var3 * var3 * 128.0F);
 
-			imageData[i * 4] = (byte) var5;
-			imageData[i * 4 + 1] = (byte) _x;
-			imageData[i * 4 + 2] = (byte) _y;
-			imageData[i * 4 + 3] = -1;
+				imageData[i * 4] = (byte) var5;
+				imageData[i * 4 + 1] = (byte) _x;
+				imageData[i * 4 + 2] = (byte) _y;
+				imageData[i * 4 + 3] = -1;
+			}
 		}
 	}
 }
